// 20200404~08	based for status 
// 20200409		resorting items (devices, io, network), trimed display of major. 
/* data type ----------------------------------- */
/* XXXXXXX0:none 		*/ 
/* XXXXXXX1:direct 		*/
/* XXXXXXX2:list 		*/
/* data output format -------------------------- */
/* XXXXXXX3:map 		*/ 
/* XXXXXX0X:none 		*/ 
/* XXXXXX1X:degree 		*/
/* XXXXXX2X:			*/
/* XXXXXX3X:	 		*/
/* content source of card title  --------------- */
/* XXXX0XXX:default	 	*/
/* XXXX1XXX:rename 		*/
/* XXXX2XXX:reserved	*/
/* XXXX4XXX:reserved 	*/
/* antenna model type  ------------------------- */
/* 0XXXXXXX:public  	*/
/* 1XXXXXXX:mk4 series 	*/
/* 2XXXXXXX:C series 	*/

var Antenna = {
	Link:{
		IsConnected:{Dat:0, ODat:0,Type:0x00001002,List:["Off","On"],Name:"Connection", display:0},
		ModelType:{Dat:0, ODat:0,Type:0x00000003,Map:[{Key:0x00,Dat:"Unknown"}, {Key:0x10,Dat:"MK4 Series"},{Key:0x20,Dat:"C Series"}], display:0},
		ModelName:{Dat:'Unknown',ODat:'Unknown',Type:0x00000001, display:0},
		Step:{Dat:0, ODat:0,Type:0x00000000}, StepString:{Dat:'', ODat:'',Type:0x00001001,Name:"Step", display:0},
		CompassMode:{Dat:0, ODat:0,Type:0x00000000}, CompassModeString:{Dat:'', ODat:'',Type:0x00001001,Name:"Compass Mode", display:0},
	},
	Operating:{  
		Step:{Dat:'', ODat:'',Type:0x00000000, display:0},
		Driving:{
			OnOff:{Dat:0, ODat:0,Type:0x00001002,List:["Off","On"],Name:"Driving On/Off", display:0}, 
			Gps:{Dat:0, ODat:0,Type:0x00001002,List:["Unknown", "Not Valid", "Valid"],Name:"GPS Status", display:0},
			Gyro:{Dat:0, ODat:0,Type:0x00001002,List:["Not Valid", "Valid"],Name:"Gyro Status", display:0},
		},
		Initialize:{
			Compass:{Dat:0, ODat:0,Type:0x00000000, display:0}, CompassString:{Dat:'', ODat:'',Type:0x00001001,Name:"Compass Mode", display:0},
		},
		Searching:{
			Operating:{Dat:0, ODat:0,Type:0x00000000, display:0}, OperatingString:{Dat:'', ODat:'',Type:0x00001001,Name:"Searching Mode", display:0}, 
			Skew:{Dat:0, ODat:0,Type:0x00000000, display:0}, SkewString:{Dat:'', ODat:'',Type:0x00001001,Name:"Skew Mode", display:0}, 
			Reference:{Dat:0, ODat:0,Type:0x00000000, display:0}, ReferenceString:{Dat:'', ODat:'',Type:0x00001001,Name:"Searching Reference", display:0}, 
			RefThreshold:{Dat:0, ODat:0,Type:0x00001000, Name:"Searching Threshold", display:0},
		},
		Tracking:{
			Reference:{Dat:0, ODat:0,Type:0x00000000, display:0}, ReferenceString:{Dat:'', ODat:'',Type:0x00001001,Name:"Tracking Reference", display:0}, 
			DecTxLoFreq:{Dat:0, ODat:0,Type:0x00001002, List:["None","Detected"],Name:"DecTxLoFreq", display:0},
		},
		Target:{
			ID:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Name:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Position:{Dat:0, ODat:0,Type:0x00000001, display:0},
		},
	},
	Functions:{
		Driving:{Dat:0, ODat:0,Type:0x00000002,List:["Off","On"], display:0 },
		Static:{Dat:0, ODat:0,Type:0x00000002,List:["Off","On"], display:0},
		Searching:{Dat:0, ODat:0,Type:0x00000002,List:["Off","On"], display:0},
		Tracking:{Dat:0, ODat:0,Type:0x00000002,List:["Off","On"], display:0},			
	},
	Signal:{
		NimAGC:{Dat:0, ODat:0,Type:0x00001001,Name:"NIM AGC", display:0},
		NimQuality:{Dat:0, ODat:0,Type:0x00001001,Name:"NIM Quality", display:0},
		Rssd:{Dat:0, ODat:0,Type:0x00001001,Name:"RSSD", display:0},
		RssdCn:{Dat:0, ODat:0,Type:0x00001001,Name:"RSSD C/N", display:0},
	},
	LookAngle:{
		/* MK4 Series */
		Elevation:{Dat:0, ODat:0,Type:0x10000011, display:0},
		Azimuth:{Dat:0, ODat:0,Type:0x10000011, display:0},
		Relative:{Dat:0, ODat:0,Type:0x10000011, display:0},
		/* C Series */
		RefBank:{Dat:0, ODat:0,Type:0x20000011, display:0},
		RefElevation:{Dat:0, ODat:0,Type:0x20000011, display:1},
		RefAzimuth:{Dat:0, ODat:0,Type:0x20000011, display:1},
		Tilt:{Dat:0, ODat:0,Type:0x20000011, display:0},
		Level:{Dat:0, ODat:0,Type:0x20000011, display:0},  
		Yaw:{Dat:0, ODat:0,Type:0x20000011, display:0},
		AhrsRoll:{Dat:0, ODat:0,Type:0x20000011, display:1},
		AhrsPitch:{Dat:0, ODat:0,Type:0x20000011, display:1},
		AhrsYaw:{Dat:0, ODat:0,Type:0x20000011, display:1},
	},
	SearchingMethod:{
		Type:{Dat:0, ODat:0,Type:0x00000000}, TypeString:{Dat:'', ODat:'',Type:0x00001001,Name:"Searching Mode", display:0},
		/* Manual Point, Manual Searching only*/
		Elevation:{Dat:0, ODat:0,Type:0x00000011, display:0},
		Azimuth:{Dat:0, ODat:0,Type:0x00000011, display:0},		
		Option:{Name:"Searching Method",Desc:{Use:false,Dat:"Display searcing method and pointing information."},Type:0},
	},
	SkewMethod:{ 
		Type:{Dat:0, ODat:0,Type:0x00000000, display:0}, TypeString:{Dat:'', ODat:'',Type:0x00001001,Name:"Skew Mode", display:0},
		/* Manual only*/
		Angle:{Dat:0, ODat:0,Type:0x00000011, display:0},		
	},
	Jog:{
		Mode:{Dat:0, ODat:0,Type:0x00000000, display:0},		
	},
	Asi:{
		Pass:{Dat:0, ODat:0,Type:0x00000000, display:0},	
	},
	Gps:{
		UseSrc:{Dat:0, ODat:0,Type:0x00001002,List:["Internal","External","Manual"],Name:"Source", display:0}, /* Manual, Internal, External */		
		Status:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received","Manual"], display:0},
		IsValids:{
			Internal:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received"], display:1},
			External:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received"], display:1},
		},
		Values:{
			IntLatitude:{Dat:0, ODat:0,Type:0x00000010, display:0},
			IntLongitude:{Dat:0, ODat:0,Type:0x00000010, display:0},
			IntSpeed:{Dat:0, ODat:0,Type:0x00000010,Name:"Speed", display:0},
			IntTrackAngle:{Dat:0, ODat:0,Type:0x00000010,Name:"Track Angle", display:0},
			ExtLatitude:{Dat:0, ODat:0,Type:0x00000010, display:0},
			ExtLongitude:{Dat:0, ODat:0,Type:0x00000010, display:0},
			ManualLatitude:{Dat:0, ODat:0,Type:0x00000010, display:0},
			ManualLongitude:{Dat:0, ODat:0,Type:0x00000010, display:0},
			UseLatitude:{Dat:0, ODat:0,Type:0x00001011,Name:"Latitude", display:0},
			UseLongitude:{Dat:0, ODat:0,Type:0x00001011,Name:"Longitude", display:0},
		},	
		GpsOutFormat:{
			Symbol:{Dat:0, ODat:0,Type:0x00000002,List:["GP","GN"], display:0},
			Type:{Dat:0, ODat:0,Type:0x00000002,List:["RMC","GLL","GGA"], display:0},
		},
		BaudRate:{Dat:0, ODat:0,Type:0x00000002,List:["1200","2400","4800","9600","19200","38400","57600","115200"], display:1},
		Option:{Name:"GPS",Type:0},
	},
	Gyro:{
		UseSrc:{Dat:0, ODat:0,Type:0x00000000,List:["External","Manual"], display:1}, /* Manual, External */
		Status:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received","Manual"], display:0},		
		IsValids:{
			Nmea2000:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received"], display:1},
			Nmea0183:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received"], display:1},
			SyncStep:{Dat:0, ODat:0,Type:0x00000002,List:["None","Received"], display:1},
		},
		Heading:{Dat:0, ODat:0,Type:0x00000011, display:0},
		HeadingValues:{
			Manual:{Dat:0, ODat:0,Type:0x00000010, display:1},
			Nmea2000:{Dat:0, ODat:0,Type:0x00000010, display:1},
			Nmea0183:{Dat:0, ODat:0,Type:0x00000010, display:1},
			SyncStep:{Dat:0, ODat:0,Type:0x00000010, display:1},
		},
		UseNMEA2000Gui:{Dat:0, ODat:0,Type:0x00000002,List:["None","Used"], display:1}, /* ExtOpt - 0 */
		Type:{Dat:0, ODat:0,Type:0x00000012, List:["NMEA0183","Synchro 360:1","Synchro 180:1","Synchro 90:1","Synchro 36:1","Synchro 1:1", "Step by Step 360:1", "Step by Step 180:1","Step by Step  90:1","NMEA2000"], display:0},
		BaudRate:{Dat:0, ODat:0,Type:0x00000002,List:["1200","2400","4800","9600","19200","38400","57600","115200"], display:1},
		Direction:{Dat:0, ODat:0,Type:0x00000002,List:["Normal","Reverse"], display:1},
		SyncFreq:{Dat:0, ODat:0,Type:0x00000002,List:["50/60Hz","400/500Hz"], display:1},
		Converter:{Dat:0, ODat:0,Type:0x00000011, display:0},
		Option:{Name:"GYRO",Type:0},
	},
	Console:{
		IsUse:{Dat:0, ODat:0,Type:0x00000000,List:["Disable","Enable"], display:0},
		LockTTL:{Dat:0, ODat:0,Type:0x00000002,List:["TTL0","TTL1"], display:0},
		GpsOutFormat:{
			Symbol:{Dat:0, ODat:0,Type:0x00000002,List:["GP","GN"], display:0},
			Type:{Dat:0, ODat:0,Type:0x00000002,List:["RMC","GLL","GGA"], display:0},
		},
		BaudRate:{Dat:0, ODat:0,Type:0x00000002,List:["1200","2400","4800","9600","19200","38400","57600","115200"], display:0},
	},
	SatInfo:{
		ID:{Dat:0, ODat:0,Type:0x00000001, display:1},
		Name:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Position:{Dat:0, ODat:0,Type:0x00000011, display:0},
		TransportFrequency:{Dat:0, ODat:0,Type:0x00000000, display:1},
		TransportSymbolRate:{Dat:0, ODat:0,Type:0x00000000, display:1},
		RxBand:{Dat:0, ODat:0,Type:0x00000010, display:0}, RxBandString:{Dat:0, ODat:0,Type:0x00001001,Name:"RxBand", display:0},
		RxPolarity:{Dat:0, ODat:0,Type:0x00000010, display:0}, RxPolarityString:{Dat:0, ODat:0,Type:0x00001001,Name:"RxPolarity", display:0},
		TxBand:{Dat:0, ODat:0,Type:0x00000010, display:1}, TxBandString:{Dat:0, ODat:0,Type:0x00001001,Name:"TxBand", display:1},
		TxPolarity:{Dat:0, ODat:0,Type:0x00000010, display:1}, TxPolarityString:{Dat:0, ODat:0,Type:0x00001001,Name:"TxPolarity", display:1},
		TRxPolarity:{Dat:0, ODat:0,Type:0x00000010, display:1}, TRxPolarityString:{Dat:0, ODat:0,Type:0x00001001,Name:"TRxPolarity", display:1},
		SearchingType:{Dat:0, ODat:0,Type:0x00000010, display:1}, SearchingTypeString:{Dat:0, ODat:0,Type:0x00001001,Name:"SearchingType", display:0},
		TrackingType:{Dat:0, ODat:0,Type:0x00000010, display:1}, TrackingTypeString:{Dat:0, ODat:0,Type:0x00001001,Name:"TrackingType", display:1}, 
		Threshold:{Dat:0, ODat:0,Type:0x00000001, display:1},
		SkewTrimmingAngle:{Dat:0, ODat:0,Type:0x00000011, display:1},
		BucLoFrequency:{Dat:0, ODat:0,Type:0x00000001, display:1},
		LnbLowLoFrequency:{Dat:0, ODat:0,Type:0x00000001, display:1},
		LnbHighLoFrequency:{Dat:0, ODat:0,Type:0x00000001, display:1},
		LnbBandSelection:{Dat:0, ODat:0,Type:0x00000001, display:1},
		NID:{Dat:0, ODat:0,Type:0x00000001, display:1},
		RollOff:{Dat:0, ODat:0,Type:0x00000011, display:1},
		Option:{Name:"Target SAT.",Type:0},
	},
	ABS:{
		IsConnected:{Dat:0, ODat:0,Type:0x00001002,List:["Off","On"],Name:"Connection", display:0},
		RcvCnt:{Dat:0, ODat:0,Type:0x00001001, display:0, Name:"Received SatInfo"},
		IsUse:{Dat:0, ODat:0,Type:0x00000002,List:["Disable","Enable"], display:0},
		ModemClass:{Dat:0, ODat:0,Type:0x00000002,List:["iDirect","ComROAM","STM VACP"], display:0},
		ProtocolType:{Dat:0, ODat:0,Type:0x00000000,List:["iDirect","ComROAM","STM VACP"], display:0},
		ExtLockSrc:{Dat:0, ODat:0,Type:0x00000002,List:["Console","Ethernet"], display:0},
		LnbBand1Lo:{Dat:0, ODat:0,Type:0x00000001, display:1},
		LnbBand2Lo:{Dat:0, ODat:0,Type:0x00000001, display:1},
		LnbBand3Lo:{Dat:0, ODat:0,Type:0x00000001, display:1},
		LnbBand4Lo:{Dat:0, ODat:0,Type:0x00000001, display:1},
		RollOff:{Dat:0, ODat:0,Type:0x00000011, display:1},
		RfTermType:{Dat:0, ODat:0,Type:0x00000001, display:1},
		Interface:{Dat:0, ODat:0,Type:0x00001002,List:["TCP/IP"],Name:"Interface", display:0},
		Port:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Option:{Name:"ABS",Type:0},
	},
	DevPcu:{
		Sn:{Dat:'', ODat:'',Type:0x00000001, display:0},
		FuncCode:{Dat:0, ODat:0,Type:0x00000001, display:0},
		ErrCode:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Temperature:{Dat:'', ODat:'',Type:0x00000011, display:0},
		Version:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Volt:{Dat:0, ODat:0,Type:0x00000011, display:1},
		Current:{Dat:0, ODat:0,Type:0x00000011, display:1},
		ActivedSlot:{Dat:0, ODat:0,Type:0x00000011, display:1},
		Option:{Name:"PCU ",Type:0},
	},
	DevAcu:{
		Sn:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Pn:{Dat:'', ODat:'',Type:0x00000001, display:1},
		ErrCode:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Temperature:{Dat:'', ODat:'',Type:0x00000011, display:0},
		Version:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Volt:{Dat:0, ODat:0,Type:0x00000011, display:1},
		Current:{Dat:0, ODat:0,Type:0x00000011, display:1},
		ActivedSlot:{Dat:0, ODat:0,Type:0x00000002,List:["Slot0","Slot1","Slot2","Slot3"], display:1},
		Option:{Name:"ACU ",Type:0},
	},
	DevBuc:{
		Sn:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Pn:{Dat:'', ODat:'',Type:0x00000001, display:0},
		OutPower:{Dat:'', ODat:'',Type:0x00000001, display:1},
		Temperature:{Dat:'', ODat:'',Type:0x00000011, display:1},
		Volt:{Dat:'', ODat:'',Type:0x00000011, display:1},
		Attn:{Dat:'', ODat:'',Type:0x00000011, display:1},
		TxOn:{Dat:0, ODat:0,Type:0x00000001, display:1},
		Fan:{Dat:0, ODat:0,Type:0x00000001, display:1},
		PllLock:{Dat:0, ODat:0,Type:0x00000001, display:1},
		Mute:{Dat:0, ODat:0,Type:0x00000001, display:1},
		IsOverTemperature:{Dat:0, ODat:0,Type:0x00000001, display:1},
		IsOverPower:{Dat:0, ODat:0,Type:0x00000001, display:1},
		IsDataIn:{Dat:0, ODat:0,Type:0x00001002,List:["None", "Linked"], Name:'Communication', display:1},
		Model:{Dat:0, ODat:0,Type:0x00000003,Map:[{Key:0x00,Dat:"Unknown"}, {Key:1,Dat:"Revgo Type1"},{Key:2,Dat:"Revgo Type2"},{Key:10,Dat:"NJRC Type1"},{Key:20,Dat:"XMW Type1"}], display:0},
		Version:{Dat:'', ODat:'',Type:0x00000001, display:1},
		Option:{Name:"BUC",Type:1},
	},
	DevLnb:{
		Sn:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Version:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Option:{Name:"LNB ",Type:0},
	},
	DevBdMux:{
		TxMuteSwitch:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Ref10MHzSwitch:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Version:{Dat:'', ODat:'',Type:0x00000001, display:0},
		Option:{Name:"BDMUX",Type:0},
	},
	Vcs:{
		IsUse:{Dat:0, ODat:0,Type:0x00000000,List:["Disable","Enable"], display:0},
		IsConnected:{Dat:0, ODat:0,Type:0x00001002,List:["Off","On"],Name:"Connection", display:0},
		Interface:{Dat:0, ODat:0,Type:0x00001002,List:["TCP/IP"],Name:"Interface", display:0},
		Port:{Dat:0, ODat:0,Type:0x00000001, display:0},
		RecvCnt:{Dat:0, ODat:0,Type:0x00001001,Name:"Recv Cnt", display:0}, /* Number of recvieved satellite information. */
		Option:{Name:"VCS",Desc:{Use:false,Dat:"TCP/IP Communication for dual antenna."},Type:0},
	},
	Mnc:{
		IsUse:{Dat:0, ODat:0,Type:0x00000000,List:["Disable","Enable"], display:0},
		IsConnected:{Dat:0, ODat:0,Type:0x00001002,List:["Off","On"],Name:"Connection", display:0},
		Interface:{Dat:0, ODat:0,Type:0x00001002,List:["TCP/IP"],Name:"Interface", display:0},
		Port:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Option:{Name:"M&C",Desc:{Use:false,Dat:"TCP/IP Communication for remote application."},Type:0},
		
		Edit:{
			
		}
	},
	Ttp:{
		IsUse:{Dat:0, ODat:0,Type:0x00000000,List:["Disable","Enable"], display:0},
		IsConnected:{Dat:0, ODat:0,Type:0x00001002,List:["Off","On"],Name:"Connection", display:0},
		Interface:{Dat:0, ODat:0,Type:0x00001002,List:["TCP/IP"],Name:"Interface", display:0},
		Port:{Dat:0, ODat:0,Type:0x00000001, display:0},
		Option:{Name:"TTP",Desc:{Use:false,Dat:"TCP/IP Communication for old CLI protocol(support status messgae only)."},Type:0},
	},
	AcuNetwork:{
		Ip0v4:{
			Addr:{Dat:0, ODat:0,Type:0x00000001, display:1},
			Sn:{Dat:0, ODat:0,Type:0x00000001, display:1},
			Gw:{Dat:0, ODat:0,Type:0x00000001, display:1},
		},
		Ip1v4:{
			Addr:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Sn:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Gw:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Option:{Name:"ETH1 IPv4",Type:0},
		},
		Port:{
			Mnc:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Abs:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Ttp:{Dat:0, ODat:0,Type:0x00000001, display:0},
			Vcs:{Dat:0, ODat:0,Type:0x00000001, display:0},
		},
		Mac:{Dat:0, ODat:0,Type:0x00000001, display:0},
		ExtNetDev:{Dat:0, ODat:0,Type:0x00000002,List:["WIFI USB Dongle","USB LAN Card"], display:0},
		Option:{Name:"Network",Type:0},
	},
	AcuIo:{
		Sw0:{Dat:0, ODat:0,Type:0x00001002,List:["ACU","VCS"], Name:"Switch 1 (Deivce)", display:0},
		Sw1:{Dat:0, ODat:0,Type:0x00001002,List:["English","Russian"], Name:"Switch 2 (Language)", display:0},
		Sw2:{Dat:0, ODat:0,Type:0x00001002,List:["-","-"], Name:"Switch 3 (Reserved)", display:0},
		Sw3:{Dat:0, ODat:0,Type:0x00001002,List:["All-in-one","Module"], display:0, Name:"Switch 4 (BDMUX)"},
		FrontType:{Dat:0, ODat:0,Type:0x00000002,List:["LED Type","Text LCD+Keys"], display:0},
		Emc0:{Dat:0, ODat:0,Type:0x00001002,List:["On","Off"], Name:"EMC CH0", display:0},
		Emc1:{Dat:0, ODat:0,Type:0x00001002,List:["On","Off"], Name:"EMC CH1", display:0},
		Emc2:{Dat:0, ODat:0,Type:0x00001002,List:["On","Off"], Name:"EMC CH2", display:0},
		Emc3:{Dat:0, ODat:0,Type:0x00000000,List:["On","Off"], Name:"EMC CH3", display:0},
		EmcSw:{Dat:0, ODat:0,Type:0x00001002,List:["On","Off"], Name:"EMC SW", display:0},
		DecRef:{Dat:0, ODat:0,Type:0x00000002,List:["None","Detected"], display:0}, 
		Option:{Name:"In/Out Port",Type:0},  
	},
	AcuFunc:{	
		Exceptions:{
			PcuDfu:{Dat:'', ODat:'',Type:0x00000001, display:0}, /* ExtOpt - 1 */
			PcuConn:{Dat:'', ODat:'',Type:0x00000001, display:0}, /* ExtOpt - 2 */
			AutoGain:{Dat:'', ODat:'',Type:0x00000001, display:0}, /* ExtOpt - 4 */
		},
		Notification:{
			Moisture:{Dat:'', ODat:'',Type:0x00000001, display:0}, /* Noti - 0 */
		},
		Pub:{
			SupprtModel:{Dat:'', ODat:'',Type:0x00000001, display:0},
			UseTleUI:{Dat:'', ODat:'',Type:0x00000001, display:0},
			LanguageType:{Dat:'', ODat:'',Type:0x00000001, display:0},
			BucPwrSync:{Dat:'', ODat:'',Type:0x00000001, display:0},
			IsUpdatePcu:{Dat:'', ODat:'',Type:0x00000001, display:0},
		},
		Option:{Name:"Functions",Type:0},
	},
	UpdateFromArray : function(arr) {
	
		//console.log(arr)
		this.Link.IsConnected.Dat= (arr[0]);
		this.Link.ModelType.Dat = (arr[1]);
		this.Link.ModelName.Dat = (arr[2]);
		this.Link.Step.Dat = (arr[3]);
		this.Link.StepString.Dat = (arr[4]);
		this.Link.CompassMode.Dat = (arr[5]);
		this.Link.CompassModeString.Dat = (arr[6]);

		this.Functions.Driving.Dat = (arr[10]);
		this.Functions.Static.Dat = (arr[11]);
		this.Functions.Searching.Dat = (arr[12]);
		this.Functions.Tracking.Dat = (arr[13]);
	
		this.Signal.NimAGC.Dat = (arr[20]);
		this.Signal.NimQuality.Dat = (arr[21]);
		this.Signal.Rssd.Dat = (arr[22]); 
		this.Signal.RssdCn.Dat = (arr[23]); 
		 
		this.LookAngle.Elevation.Dat = parseFloat(arr[40]);
		this.LookAngle.Azimuth.Dat = parseFloat(arr[41]);
		this.LookAngle.Relative.Dat = parseFloat(arr[42]);
		this.LookAngle.RefBank.Dat = parseFloat(arr[43]);
		this.LookAngle.RefElevation.Dat = parseFloat(arr[44]); 
		this.LookAngle.RefAzimuth.Dat = parseFloat(arr[45]);
		this.LookAngle.Tilt.Dat = parseFloat(arr[46]);
		this.LookAngle.Level.Dat = parseFloat(arr[47]);
		this.LookAngle.Yaw.Dat = parseFloat(arr[48]);
		this.LookAngle.AhrsRoll.Dat = parseFloat(arr[49]); 
		this.LookAngle.AhrsPitch.Dat = parseFloat(arr[50]);
		this.LookAngle.AhrsYaw.Dat = parseFloat(arr[51]);
		
		this.SearchingMethod.Type.Dat = (arr[60]);
		this.SearchingMethod.TypeString.Dat = (arr[61]);
		this.SearchingMethod.Elevation.Dat = this.LookAngle.Elevation.Dat;
		this.SearchingMethod.Azimuth.Dat = this.LookAngle.Azimuth.Dat;
		
		this.SkewMethod.Type.Dat = (arr[70]);
		this.SkewMethod.TypeString.Dat = (arr[71]);
		this.SkewMethod.Angle.Dat = (arr[72]);
		
		this.Jog.Mode.Dat = (arr[80]);
		
		this.Asi.Pass.Dat = (arr[90]);
		

		this.Gps.UseSrc.Dat = (arr[100]);
		this.Gps.Status.Dat = (arr[101])==0?(arr[101]):(arr[101])==1?(arr[102]):(arr[100]);
		this.Gps.IsValids.Internal.Dat = (arr[101]);
		this.Gps.IsValids.External.Dat = (arr[102]);
		this.Gps.Values.IntLatitude.Dat = parseFloat(arr[103]);
		this.Gps.Values.IntLongitude.Dat = parseFloat(arr[104]);
		this.Gps.Values.IntSpeed.Dat = parseFloat(arr[105]);
		this.Gps.Values.IntTrackAngle.Dat = parseFloat(arr[106]);
		this.Gps.Values.ExtLatitude.Dat = parseFloat(arr[107]);
		this.Gps.Values.ExtLongitude.Dat = parseFloat(arr[108]);
		this.Gps.Values.ManualLatitude.Dat = parseFloat(arr[109]);
		this.Gps.Values.ManualLongitude.Dat = parseFloat(arr[110]);
		this.Gps.Values.UseLatitude.Dat = parseFloat(arr[111]);
		this.Gps.Values.UseLongitude.Dat = parseFloat(arr[112]);
		this.Gps.GpsOutFormat.Symbol.Dat = (arr[113]);
		this.Gps.GpsOutFormat.Type.Dat = (arr[114]);
		this.Gps.BaudRate.Dat = (arr[115]);
		

		this.Gyro.UseSrc.Dat = (arr[120]); 
		this.Gyro.IsValids.Nmea2000.Dat = (arr[121]); 
		this.Gyro.IsValids.Nmea0183.Dat = (arr[122]); 
		this.Gyro.IsValids.SyncStep.Dat = (arr[123]);
		this.Gyro.Heading.Dat = parseFloat(arr[128]); 
		this.Gyro.HeadingValues.Manual.Dat = parseFloat(arr[124]);
		this.Gyro.HeadingValues.Nmea2000.Dat = parseFloat(arr[125]); 
		this.Gyro.HeadingValues.Nmea0183.Dat = parseFloat(arr[126]); 
		this.Gyro.HeadingValues.SyncStep.Dat = parseFloat(arr[127]); 
		this.Gyro.UseNMEA2000Gui.Dat = (arr[129]);
		this.Gyro.Type.Dat = (arr[130]); 
		this.Gyro.BaudRate.Dat = (arr[131]);  
		this.Gyro.Direction.Dat = (arr[132]);  
		this.Gyro.SyncFreq.Dat = (arr[133]);  
		this.Gyro.Converter.Dat = parseFloat(arr[134]);   
			
		this.Console.IsUse.Dat = (arr[140]); 
		this.Console.LockTTL.Dat = (arr[141]); 
		this.Console.GpsOutFormat.Symbol.Dat = (arr[142]); 
		this.Console.GpsOutFormat.Type.Dat = (arr[143]); 
		this.Console.BaudRate.Dat = (arr[144]); 
		
	
		
		this.SatInfo.ID.Dat = (arr[150]); 
		this.SatInfo.Name.Dat = (arr[151]);
		this.SatInfo.Position.Dat = parseFloat(arr[152]);
		this.SatInfo.RxBand.Dat = (arr[153]);
		this.SatInfo.RxBandString.Dat = (arr[154]);
		this.SatInfo.RxPolarity.Dat = (arr[155]);
		this.SatInfo.RxPolarityString.Dat = (arr[156]);
		this.SatInfo.TxBand.Dat = (arr[157]);
		this.SatInfo.TxBandString.Dat = (arr[158]);
		this.SatInfo.TxPolarity.Dat = (arr[159]);
		this.SatInfo.TxPolarityString.Dat = (arr[160]);
		this.SatInfo.TRxPolarity.Dat = (arr[161]);
		this.SatInfo.TRxPolarityString.Dat = (arr[162]);
		this.SatInfo.SearchingType.Dat = (arr[163]);
		this.SatInfo.SearchingTypeString.Dat = (arr[164]);
		this.SatInfo.TrackingType.Dat = (arr[165]);
		this.SatInfo.TrackingTypeString.Dat = (arr[166]);
			
		this.ABS.IsConnected.Dat = (arr[181]); 
		this.ABS.RcvCnt.Dat = (arr[182]); 	
		this.ABS.IsUse.Dat = (arr[183]); 
		this.ABS.ModemClass.Dat = (arr[184]); 
		this.ABS.ProtocolType.Dat = (arr[185]); 
		this.ABS.ExtLockSrc.Dat = (arr[186]); 
		this.ABS.LnbBand1Lo.Dat = (arr[187]); 
		this.ABS.LnbBand2Lo.Dat = (arr[188]); 
		this.ABS.LnbBand3Lo.Dat = (arr[189]); 
		this.ABS.LnbBand4Lo.Dat = (arr[190]); 
		this.ABS.RollOff.Dat = (arr[191]); 
		this.ABS.RfTermType.Dat = (arr[192]); 
		

		this.DevPcu.Sn.Dat = (arr[200]);
		this.DevPcu.FuncCode.Dat = (arr[201]);
		this.DevPcu.ErrCode.Dat = (arr[202]);
		this.DevPcu.Temperature.Dat = parseFloat(arr[203]);
		this.DevPcu.Version.Dat = (arr[204]);
		this.DevPcu.Volt.Dat = parseFloat(arr[205]);
		this.DevPcu.Current.Dat = parseFloat(arr[206]);
		this.DevPcu.ActivedSlot.Dat = (arr[209]);

		this.DevAcu.Sn.Dat = (arr[210]);
		this.DevAcu.Pn.Dat = (arr[211]);
		this.DevAcu.ErrCode.Dat = (arr[212]);
		this.DevAcu.Temperature.Dat = parseFloat(arr[213]);
		this.DevAcu.Version.Dat = (arr[214]);
		this.DevAcu.Volt.Dat = parseFloat(arr[215]);
		this.DevAcu.Current.Dat = parseFloat(arr[216]);
		this.DevAcu.ActivedSlot.Dat = (arr[249]);

		this.DevBuc.Sn.Dat = (arr[250]);
		this.DevBuc.Pn.Dat = (arr[251]);
		this.DevBuc.OutPower.Dat = (arr[252]);
		this.DevBuc.Temperature.Dat = parseFloat(arr[253]);
		this.DevBuc.Volt.Dat = parseFloat(arr[254]);
		this.DevBuc.Attn.Dat = parseFloat(arr[255]);
		this.DevBuc.TxOn.Dat = (arr[256]);
		this.DevBuc.Fan.Dat = (arr[257]);
		this.DevBuc.PllLock.Dat = (arr[258]);
		this.DevBuc.Mute.Dat = (arr[259]);
		this.DevBuc.IsOverTemperature.Dat = (arr[260]);
		this.DevBuc.IsOverPower.Dat = (arr[261]);
		this.DevBuc.IsDataIn.Dat = (arr[262]);
		this.DevBuc.Model.Dat = (arr[263]);
		this.DevBuc.Version.Dat = (arr[264]);

		this.DevLnb.Sn.Dat = (arr[270]);
		this.DevLnb.Version.Dat = (arr[271]);

		this.DevBdMux.TxMuteSwitch.Dat = (arr[280]); 
		this.DevBdMux.Ref10MHzSwitch.Dat = (arr[281]); 
		this.DevBdMux.Version.Dat = (arr[282]); 
		
		
		
		

		this.AcuFunc.Exceptions.PcuDfu.Dat = (arr[400]);  /* ExtOpt - 1 */
		this.AcuFunc.Exceptions.PcuConn.Dat = (arr[401]);  /* ExtOpt - 2 */
		this.AcuFunc.Exceptions.AutoGain.Dat = (arr[402]);  /* ExtOpt - 4 */
		
		this.AcuFunc.Notification.Moisture.Dat = (arr[420]);  /* Noti - 0 */
		
		this.AcuFunc.Pub.SupprtModel.Dat = (arr[430]);  
		this.AcuFunc.Pub.UseTleUI.Dat = (arr[431]); 
		this.AcuFunc.Pub.LanguageType.Dat = (arr[432]); 
		this.AcuFunc.Pub.BucPwrSync.Dat = (arr[433]); 
		this.AcuFunc.Pub.IsUpdatePcu.Dat = (arr[434]);  
		
		this.AcuNetwork.Ip0v4.Addr.Dat = (arr[360]);
		this.AcuNetwork.Ip0v4.Sn.Dat = (arr[361]);
		this.AcuNetwork.Ip0v4.Gw.Dat = (arr[362]);
		this.AcuNetwork.Ip1v4.Addr.Dat = (arr[363]);
		this.AcuNetwork.Ip1v4.Sn.Dat = (arr[364]);
		this.AcuNetwork.Ip1v4.Gw.Dat = (arr[365]);
		this.AcuNetwork.Port.Mnc.Dat = (arr[366]);
		this.AcuNetwork.Port.Abs.Dat = (arr[367]); 
		this.AcuNetwork.Port.Ttp.Dat = (arr[368]); 
		this.AcuNetwork.Port.Vcs.Dat = (arr[369]); 
		this.AcuNetwork.Mac.Dat = (arr[370]);
		this.AcuNetwork.ExtNetDev.Dat = (arr[371]);
		
		
		this.Vcs.IsUse.Dat = (arr[300]); 
		this.Vcs.IsConnected.Dat = (arr[301]); 
		this.Vcs.RecvCnt.Dat = (arr[302]); 
		this.Vcs.Port.Dat = this.AcuNetwork.Port.Vcs.Dat; 
 
		this.Mnc.IsUse.Dat = (arr[310]); 
		this.Mnc.IsConnected.Dat = (arr[311]); 
		this.Mnc.Port.Dat = this.AcuNetwork.Port.Mnc.Dat; 
		
		this.Ttp.IsUse.Dat = (arr[320]); 
		this.Ttp.IsConnected.Dat = (arr[321]); 
		this.Ttp.Port.Dat = this.AcuNetwork.Port.Ttp.Dat; 
		
		this.ABS.RfTermType.Dat = (arr[192]); 
		this.ABS.Port.Dat = this.AcuNetwork.Port.Abs.Dat; 
		
		
		this.AcuIo.DecRef.Dat = (arr[380]);
		this.AcuIo.Sw0.Dat = (arr[381]);
		this.AcuIo.Sw1.Dat = (arr[382]);
		this.AcuIo.Sw2.Dat = (arr[383]);
		this.AcuIo.Sw3.Dat = (arr[384]);
		this.AcuIo.FrontType.Dat = (arr[385]);
		/* Check Bdmux module type */
		if(this.AcuIo.Sw3.Dat!=0) this.AcuIo.Emc0.Type = this.AcuIo.Emc1.Type = this.AcuIo.Emc2.Type = this.AcuIo.EmcSw.Type = 0x00001002;
		else this.AcuIo.Emc0.Type = this.AcuIo.Emc1.Type = this.AcuIo.Emc2.Type = this.AcuIo.Emc3.Type = this.AcuIo.EmcSw.Type = 0x00000000;
		this.AcuIo.Emc0.Dat = (arr[386]);
		this.AcuIo.Emc1.Dat = (arr[387]);
		this.AcuIo.Emc2.Dat = (arr[388]);
		this.AcuIo.EmcSw.Dat = (arr[390]);
		
		
		this.Operating.Step.Dat = this.Link.Step.Dat;
		this.Operating.Driving.OnOff.Dat = this.Functions.Driving.Dat;
		this.Operating.Driving.Gps.Dat = this.Gps.IsValids.Internal.Dat | this.Gps.IsValids.External.Dat;
		this.Operating.Driving.Gyro.Dat = this.Gyro.IsValids.Nmea2000.Dat | this.Gyro.IsValids.Nmea0183.Dat | this.Gyro.IsValids.SyncStep.Dat;
		this.Operating.Initialize.Compass.Dat = this.Link.CompassMode.Dat;
		this.Operating.Initialize.CompassString.Dat = this.Link.CompassModeString.Dat;
		this.Operating.Searching.Operating.Dat = this.SearchingMethod.Type.Dat;
		this.Operating.Searching.OperatingString.Dat = this.SearchingMethod.TypeString.Dat;
		this.Operating.Searching.Skew.Dat = this.SkewMethod.Type.Dat;
		this.Operating.Searching.SkewString.Dat = this.SkewMethod.TypeString.Dat;
		this.Operating.Searching.Reference.Dat = this.SatInfo.SearchingType.Dat;
		this.Operating.Searching.ReferenceString.Dat =  this.SatInfo.SearchingTypeString.Dat;
		this.Operating.Searching.RefThreshold.Dat = 0;
		this.Operating.Tracking.Reference.Dat = this.SatInfo.TrackingType.Dat;
		this.Operating.Tracking.ReferenceString.Dat = this.SatInfo.TrackingTypeString.Dat;
		this.Operating.Tracking.DecTxLoFreq.Dat = this.AcuIo.DecRef.Dat;
		this.Operating.Target.ID.Dat = this.SatInfo.ID.Dat; 
		this.Operating.Target.Name.Dat = this.SatInfo.Name.Dat;
		this.Operating.Target.Position.Dat = this.SatInfo.Position.Dat;

	},
 };
		